<template>
  <v-card height="100%" class="elevation-0 d-flex flex-column">
    <v-card-text>
      <v-tabs centered color="primary" v-model="tab">
        <v-tabs-slider></v-tabs-slider>
        <v-tab> <v-icon left>mdi-numeric</v-icon>Logs </v-tab>
        <v-tab @click="error_dot = false">
          <v-icon left>mdi-alert-circle</v-icon>
          <v-badge color="error" :value="error_dot" dot>Errors</v-badge>
        </v-tab>
        <v-tab @click="message_dot = false">
          <v-icon left>mdi-email</v-icon>
          <v-badge color="info" :value="message_dot" dot>Messages</v-badge>
        </v-tab>

        <v-tab-item>
          <LogsVisualizer />
        </v-tab-item>

        <v-tab-item>
          <ErrorsVisualizer />
        </v-tab-item>

        <v-tab-item>
          <MessageVisualizer />
        </v-tab-item>
      </v-tabs>

      <v-spacer />
    </v-card-text>
    <v-spacer></v-spacer>
    <v-card-actions>
      <span v-if="Array.isArray(last_log) && last_log.length">
        {{ logsSec }} logs/s
        <v-tooltip right>
          <template v-slot:activator="{ on, attrs }">
            <v-icon v-bind="attrs" v-on="on">mdi-help-circle</v-icon>
          </template>
          <span
            >Depending on the logging frequency this value might be slightly
            inaccurate</span
          >
        </v-tooltip>
      </span>
    </v-card-actions>
  </v-card>
</template>

<script>
import ErrorsVisualizer from "./BoardOverview/Logs/ErrorsVisualizer";
import { Error } from "@/plugins/data_structures/Coms";
import { ErrorType } from "@/plugins/data_structures/Enums";
import LogsVisualizer from "./BoardOverview/Logs/LogsVisualizer";
import MessageVisualizer from "./BoardOverview/Logs/MessageVisualizer";

export default {
  name: "Logs",
  data: () => ({
    tab: 0,
    error_dot: false,
    message_dot: false,
  }),
  components: {
    ErrorsVisualizer,
    LogsVisualizer,
    MessageVisualizer,
  },
  methods: {
    handleError(error) {
      if (error.type != ErrorType.CHECKSUM) {
        // print error
        this.$notify.error(error.message);
      }
      this.$store.dispatch("coms/pushError", error);
      this.error_dot = true;
    },
  },
  computed: {
    last_log() {
      return this.$store.getters["logs/last_log"];
    },
    logsSec() {
      return this.$store.getters["status/logsSec"];
    },
  },
  created() {
    this.$socket.on("error", (data) => {
      if (data.type == ErrorType.MSG) {
        this.$store.dispatch("coms/pushMessage", data.message);
        this.message_dot = true;
        this.$notify.info(data.message);
      } else {
        let err = new Error(data.type, data.message);
        this.handleError(err);
      }
    });
  },
};
</script>

<style scoped>
v-card {
  text-align: center;
}
</style>